/*
from, out of, out from, away from, proceeding from,
coming from, going from, about, concerning, as concerns,
pertaining to, appertaining to, peculiar to, attributed to,
characterized by, regarding, as regards, in regard to, referring to,
in reference to, appropriate to, like, belonging to, related to,
having relation to, native to, consequent to, based on, akin to,
consanguineous to, connected with
*/
/*                                                                    *\
								Palette Swapping
							 (for use with the GIMP)
								----------------
	Red    -Color Balance- Highlights:  Top --> Bottom/Mid <--
	Yellow -Color Balance- Highlights:  Bottom <-- Top/Mid -->
	Blue   -Color Balance- Highlights:  Bottom --> Top/Mid <--
	Dark   -   Levels    - Input .2
	Crystal-HueSaturation- Mid --> Replace Hilt
	Silver -HueSaturation- Bottom <-- Top/Mid <->
	Gold   -Color Balance- Highlights:  Bottom <-- Top/Mid -->
						   Midtones:    Bottom <-- Top/Mid -->

\* 																	  */
	//these are the Suffixes of the weapons, not as important, yet anyhow.
var/list
	Suffixes=list(" of the Pyre"," of the Chill"," of Thor"," of the Order",\
				  " of the Gods")
	//" from the Pit"," from the Arctic"," of the Blaze"," of Thunder"

	//these are the Prefixes to the weapons, the order is highly important
	Prefixes=list("Flaming ","Searing ","Scorching ","Frozen ","Arctic ","Glacial ",\
				  "Shocking ","Bolting ","Tempest ","Silver ","Golden ","Crystalline ",\
				  "Dragon's ","Wyrm's ","Boar's ","Vampiric ","Myrrh's ","Magical ","Mana's ",\
				  "Osmotic ")
	//"Thunderous ","Frosty "

	//simplifying my work here.
	Yellow =list(" of Thor"," of Thunder","Shocking ","Bolting ","Tempest ","Thunderous ")
	Red    =list(" of the Pyre"," from the Pit"," of the Blaze","Flaming ","Searing ","Scorching ")
	Blue   =list(" of the Chill"," from the Arctic","Frozen ","Arctic ","Glacial ","Frosty ")
	Dark   =list()
	Silver =list("Silver ")
	Golden =list("Golden ")
	Crystal=list("Crystalline ")

obj/gear/var

	//define the various variables we will be using; compressed but uniform
	itemlevel   =0;manabonus   =0;healthbonus =0;staminabonus=0;forcebonus=0;bodybonus=0;
	agilitybonus=0;mindbonus   =0;wisdombonus =0;value     =0;Type    ="";list/effects=list()
	Prefix     ="";Suffix     ="";description="";owner      ="";

	//spell boosts, all replaceable
	firebonus   =0;earthbonus  =0;waterbonus =0;boltbonus   =0;holybonus =0;darkbonus=0;
	windbonus   =0;healingbonus=0;
obj/gear/proc

	//we gotta prevent stupid shit. Bolting Dagger of the Flame, Frozen Dagger of the Flame, etc.
	suffpref()
		if(Suffix==Suffixes[1])
			if(Prefix==Prefixes[4]||Prefix==Prefixes[5]||Prefix==Prefixes[6]||Prefix==Prefixes[7]||Prefix==Prefixes[8]||Prefix==Prefixes[9])
				if(prob(50))
					Suffix=" of the Blaze"
					Prefix=""
				else
					Suffix=" from the Pit"
					Prefix=""
		if(Suffix==Suffixes[2])
			if(Prefix==Prefixes[1]||Prefix==Prefixes[2]||Prefix==Prefixes[3]||Prefix==Prefixes[7]||Prefix==Prefixes[8]||Prefix==Prefixes[9])
				if(prob(50))
					Suffix=""
					Prefix="Frosty "
				else
					Suffix=" from the Arctic"
					Prefix=""
		if(Suffix==Suffixes[3])
			if(Prefix==Prefixes[1]||Prefix==Prefixes[2]||Prefix==Prefixes[3]||Prefix==Prefixes[4]||Prefix==Prefixes[5]||Prefix==Prefixes[6])
				if(prob(50))
					Suffix=""
					Prefix="Thunderous "
				else
					Suffix=" of Thunder"
					Prefix=""
		prefixbonus()
		suffixbonus()

	//well, those suffixes have to mean SOMETHING, I guess..
	suffixbonus()
		switch(Suffix)
			if(" of the Pyre")
				switch(itemlevel)
					if(1){firebonus+=1;manabonus+=rand(30,45);value+=rand(1,25)}
					if(2){firebonus+=1;manabonus+=rand(39,49);value+=rand(1,25)}
			if(" of the Blaze")
				switch(itemlevel)
					if(1){firebonus+=rand(1,2);manabonus+=rand(25,45);value+=rand(1,25)}
					if(2){firebonus+=rand(1,2);manabonus+=rand(25,45);value+=rand(1,25)}
			if(" from the Pit")
				switch(itemlevel)
					if(1){firebonus+=2;manabonus+=rand(40,45);value+=rand(1,25)}
					if(2){firebonus+=3;manabonus+=rand(50,65);value+=rand(1,25)}
			if(" of the Chill")
				switch(itemlevel)
					if(1){waterbonus+=1;manabonus+=rand(30,60);value+=rand(1,25)}
					if(2){waterbonus+=1;manabonus+=rand(34,68);value+=rand(1,25)}
			if(" from the Arctic")
				switch(itemlevel)
					if(1){waterbonus+=rand(1,2);manabonus+=rand(40,60);value+=rand(1,25)}
					if(2){waterbonus+=rand(1,3);manabonus+=rand(55,70);value+=rand(1,25)}
			if(" of Thor")
				switch(itemlevel)
					if(1){boltbonus+=rand(1,2);manabonus+=rand(45,60);value+=rand(1,25)}
					if(2){boltbonus+=rand(1,3);manabonus+=rand(55,75);value+=rand(1,25)}
			if(" of Thunder")
				switch(itemlevel)
					if(1){boltbonus+=rand(1,2);manabonus+=rand(55,70);value+=rand(1,25)}
					if(2){boltbonus+=rand(2,3);manabonus+=rand(70,80);value+=rand(1,25)}
			if(" of the Gods")
				switch(itemlevel)
					if(1){healthbonus+=rand(20,30);manabonus+=rand(20,35);value+=rand(1,25)}
					if(2){healthbonus+=rand(40,50);manabonus+=rand(30,45);value+=rand(1,25)}
			if(" of the Order")
				switch(itemlevel)
					if(2){addeffect("Slayer");holybonus+=1;manabonus+=rand(30,40);value+=rand(1,25)}
					if(2){addeffect("Slayer");holybonus+=rand(1,2);manabonus+=rand(30,60);value+=rand(1,25)}

	//I feel like I'm repeating myself at this point
	prefixbonus()
		switch(Prefix)
			if("Flaming ")
				switch(itemlevel)
					if(1){firebonus+=1;manabonus+=rand(5,10);value+=rand(1,25)}
					if(2){firebonus+=2;manabonus+=rand(15,30);value+=rand(1,25)}
			if("Searing ")
				switch(itemlevel)
					if(1){firebonus+=2;manabonus+=rand(15,20);value+=rand(1,25)}
					if(2){addeffect("Burn");firebonus+=2;manabonus+=rand(15,20);value+=rand(1,25)}
			if("Scorching ")
				switch(itemlevel)
					if(1){firebonus+=2;manabonus+=rand(25,30);value+=rand(1,25)}
					if(2){addeffect("Burn");firebonus+=3;manabonus+=rand(35,40);value+=rand(1,25)}
			if("Frozen ")
				switch(itemlevel)
					if(1){waterbonus+=1;wisdombonus+=rand(1,2);value+=rand(1,25)}
					if(2){addeffect("Freeze");waterbonus+=2;wisdombonus+=rand(2,3);value+=rand(1,25)}
			if("Arctic ")
				switch(itemlevel)
					if(1){waterbonus+=1;wisdombonus+=rand(1,2);value+=rand(1,25)}
					if(2){waterbonus+=2;wisdombonus+=2;value+=rand(1,25)}
			if("Glacial ")
				switch(itemlevel)
					if(1){waterbonus+=1;wisdombonus+=rand(3,4);value+=rand(1,25)}
					if(2){addeffect("Freeze");waterbonus+=3;wisdombonus+=3;value+=rand(1,25)}
			if("Frosty ")
				switch(itemlevel)
					if(1){waterbonus+=2;wisdombonus+=rand(4,5);value+=rand(1,25)}
					if(2){addeffect("Freeze");waterbonus+=3;wisdombonus+=rand(5,6);value+=rand(1,25)}
			if("Shocking ")
				switch(itemlevel)
					if(1){boltbonus+=1;forcebonus+=rand(1,2);value+=rand(1,25)}
					if(2){boltbonus+=2;forcebonus+=rand(2,3);value+=rand(1,25)}
			if("Bolting ")
				switch(itemlevel)
					if(1){boltbonus+=2;forcebonus+=rand(3,4);value+=rand(1,25)}
					if(2){addeffect("Stun");boltbonus+=2;forcebonus+=rand(3,4);value+=rand(1,25)}
			if("Tempest ")
				switch(itemlevel)
					if(1){boltbonus+=2;forcebonus+=rand(2,3);value+=rand(1,25)}
					if(2){addeffect("Stun");boltbonus+=3;forcebonus+=rand(5,6);value+=rand(1,25)}
			if("Thunderous ")
				switch(itemlevel)
					if(1){boltbonus+=2;forcebonus+=rand(4,5);value+=rand(1,25)}
					if(2){addeffect("Stun");boltbonus+=3;forcebonus+=rand(5,6);value+=rand(1,25)}
			if("Silver ")
				switch(itemlevel)
					if(1){addeffect("Silver");holybonus+=1;agilitybonus+=1;value+=rand(1,25)}
					if(2){addeffect("Silver");holybonus+=rand(1,2);agilitybonus+=rand(1,2);value+=rand(1,25)}

				//as if the "special effect: silver wasn't enough
				description+=" This item is forged of silver."
			if("Golden ")
				switch(itemlevel)
					if(1){earthbonus+=1;staminabonus+=rand(12,22);value+=rand(1,25)}
					if(2){earthbonus+=rand(1,2);staminabonus+=rand(32,45);value+=rand(1,25)}
			if("Crystalline ")
				switch(itemlevel)
					if(1){addeffect("Piercing");healingbonus+=1;healthbonus+=rand(22,31);manabonus+=rand(22,31);value+=rand(1,25)}
					if(2){addeffect("Piercing");healingbonus+=rand(1,2);healthbonus+=rand(32,45);manabonus+=rand(32,45);value+=rand(1,25)}
				switch(Type)
					if("shield")bodybonus+=rand(3*itemlevel,4*itemlevel)
				description+=" This item is made of crystal."
	//simple
	addeffect(text)
		effects+=text

	//choosing a color now!
	colordefine()
		if(Yellow.Find(Prefix)||Yellow.Find(Suffix))return "Yellow"
		if(Red.Find(Prefix)||Red.Find(Suffix))return "Red"
		if(Blue.Find(Prefix)||Blue.Find(Suffix))return "Blue"
		if(Dark.Find(Prefix)||Dark.Find(Suffix))return "Dark"
		if(Silver.Find(Prefix)||Silver.Find(Suffix))return "Silver"
		if(Golden.Find(Prefix)||Golden.Find(Suffix))return "Golden"
		if(Crystal.Find(Prefix)||Crystal.Find(Suffix))return "Crystalline"
		return ""
	//this is my html chunk generator. It looks nicer when it's used to show it, instead
	//of looking at it :D
	determinedesc(target)

		//start up the html block
		var/desc = "<html><body bgcolor=black text=red link=blue vlink=white alink=purple>"
		desc+="<center><FONT FACE=Courier New><b><head>[name]</head></font></center></b><br><br>"
		desc+="<body><FONT FACE=Sand>"
		desc+="Item level:  [itemlevel]<br>"
		desc+="Item value:  [value] aureu<br>"
		desc+="Owner:  [owner]<br>"

		//if there are no vital bonuses, why bother showing that?
		if(healthbonus||manabonus||staminabonus||forcebonus||bodybonus||agilitybonus||mindbonus||wisdombonus)desc+="<u>Vital Statistic Increases</u>:<br><br>"

		//but if there are...
		if(healthbonus) desc+="<i>Health Bonus:</i>  [healthbonus]<br>"
		if(manabonus)   desc+="<i>Mana Bonus:</i>  [manabonus]<br>"
		if(staminabonus)desc+="<i>Stamina Bonus:</i>  [staminabonus]<br>"
		if(forcebonus)  desc+="<i>Force Bonus:</i>  [forcebonus]<br>"
		if(bodybonus)   desc+="<i>Body Bonus:</i>  [bodybonus]<br>"
		if(agilitybonus)desc+="<i>Agility Bonus:</i>  [agilitybonus]<br>"
		if(mindbonus)   desc+="<i>Mind Bonus:</i>  [mindbonus]<br>"
		if(wisdombonus) desc+="<i>Wisdom Bonus:</i>  [wisdombonus]<br>"
		desc+="<br>"

		//no effects? don't show
		if(firebonus||earthbonus||waterbonus||boltbonus||holybonus||darkbonus||windbonus||healingbonus)desc+="<u>Magical Statistic Increases</u>:<br><br>"

		//need to explain again? too bad,
		if(firebonus)   desc+="<i>Fire Elemental Bonus:</i>  [firebonus]<br>"
		if(waterbonus)  desc+="<i>Water Elemental Bonus:</i>  [waterbonus]<br>"
		if(boltbonus)   desc+="<i>Electrical Elemental Bonus:</i>  [boltbonus]<br>"
		if(earthbonus)  desc+="<i>Earth Elemental Bonus:</i>  [earthbonus]<br>"
		if(windbonus)  	desc+="<i>Wind Elemental Bonus:</i>  [windbonus]<br>"
		if(healingbonus)desc+="<i>Healing Elemental Bonus:</i>  [healingbonus]<br>"
		if(holybonus)   desc+="<i>Holy Elemental Bonus:</i>  [holybonus]<br>"
		if(darkbonus)   desc+="<i>Dark Elemental Bonus:</i>  [darkbonus]<br>"
		desc+="<br>"

		//we want to see all your effects mister item!
		if(effects)for(var/o in effects)desc+="<i>Special Effect:</i>  \"[o]\"<br>"

		//close the html
		desc+="<br>"
		desc+="[description]<br>"
		desc+="</body>"
		desc += "<tr><td><a href=byond://?src=\ref[usr];action=close></u>"
		desc += "</u><center>Close</a></center>"

		//show the html
		winset(target, "popup", "is-visible=true")
		target << browse(desc)
obj/gear/verb
	checkmeout()

	//I'm finally learning some html. horray!
		determinedesc(usr)

	//want to brag to someone else? No copy pasta needed!
	showmeoff(var/mob/c in world)
		if(alert(c,"do you want to see [usr]'s [src.name]?",,"yes","no")=="yes")
			determinedesc(c)

	//we're definitely overriding new() to do these fancy stuffs.
obj/gear/New(var/magical=FALSE,wpnlvl,ownager)

	//but only if it's magical, otherwise we let it get created normally.
	itemlevel=wpnlvl
	owner=ownager

	//you failed at making the item, you should just not try
	if(!itemlevel){world << "Item creation aborted; no weapon level.";return}
	if(magical)

	//more yummy money
		value=round((value*1.5)*(itemlevel+1))
		switch(itemlevel)
			if(1)
				if(prob(100))

					//ass-backwards, but whatever, I like the way it looks...
					//it modifies the chances somehow, I don't know the odds well, but it does!
					//everything does something special, boost in some way, otherwise, what's the point?
					//this is incredibly compressed, so it won't be commented
					Prefix=pick(Prefixes[rand(1,2)],Prefixes[rand(4,5)],Prefixes[rand(7,8)])

				if(prob(100))

					//pick from the basic Suffixes, fire, ice, lightning, nothing special.
					Suffix=pick(Suffixes[1],Suffixes[2],Suffixes[3])
			if(2)
				if(prob(100))

					//choose one of the cooler prefixes. I mean, level 2 is where it's at.
					Prefix=pick(Prefixes[rand(2,3)],Prefixes[rand(5,6)],Prefixes[rand(8,9)],Prefixes[rand(10,12)])
				if(prob(100))

					//ditching the old Suffixes!
					Suffix=pick(Suffixes[4],Suffixes[5])
		suffpref()
		icon_state="[colordefine()][icon_state]"
		name="[Prefix][name][Suffix]"
	//we aren't magical :( but I bet you know that by now.
	else ..()

	//gear declaration
obj/gear/weapon
	icon='Weapons.dmi'
	Type="weapon"
	Dagger
		icon_state="D"
		value=5
		forcebonus=3
		description="A simple dagger, crafted of metal."
obj/gear/armor
	icon='Armor.dmi'
	Type="armor"
	Leather_Armor
		icon_state="Leather"
		value=5
		bodybonus=4
obj/gear/accessory
	icon='Amulets.dmi'
	Type="accessory"
	Amulet
obj/gear/shield
	icon='Weapons.dmi'
	Type="shield"
	Wooden_Shield
		icon_state="Shield"
		value=5
		bodybonus=2
mob/proc
	updateinv()
		var/num=0
		var/col=0
		for(var/obj/o in contents) src << output(o,"grid:[++num].[col]")

	//just some debugging verbs
client/verb
	checkeffects()
		if(!mob.contents.len)return
		var/obj/gear/d=input("which item?") in mob
		if(d)for(var/t in d.effects) world << t
	addeffect(t as text)
		var/obj/gear/weapon/Dagger/d=new(mob)
		d.effects+=t
		mob.updateinv()
	searcheffects(t as text)
		if(!mob.contents.len)return
		var/obj/gear/d=input("which item?") in mob.contents
		if(d.effects.Find(t))world << "[t] exists"
	makemagical()
		var/x=alert(mob,"magical?",,"TRUE","FALSE")
		var/u=input(mob,"level?")as num
		var/obj/gear/weapon/Dagger/d=new(mob,magical=x,wpnlvl=u)
		if(alert(mob,"effects?",,"yes","no")=="yes")
			var/n=input(mob,"how many?")as num
			while(n>0)
				var/t=input("what is it called?")as text
				d.effects+="[t]"
				n--
		mob.updateinv()
	makerandom()
		new/obj/gear/weapon/Dagger(mob,magical=TRUE,wpnlvl=rand(1,2),ownager=mob)
		mob.updateinv()

	//yes I would like that close button to do something
atom/Topic(href,href_list[])
	switch(href_list["action"])
		if("close")
			winset(src,"popup","is-visible=false")

